function [delayfree, loops, operands] = delayfreeloops(sfg)
% This function finds all delay free loops in a signal flow graph.
% Each row in 'delayfree' corresponds to one delay free loop and contain all nodes in the loop.

delay_op = getidfromname('delay');

[loops, operands] = findloops(sfg);
opsize = size(operands);
if opsize(2) < delay_op
    delayfree = loops;
else
    delayfree = [];
    rows = find(~operands(:, delay_op));
    for i = 1:length(rows)
        nodes = sum(~isnan(loops(rows(i), :)));
        delayfree = addrow(delayfree, loops(rows(i), 1:nodes));
    end
end
