function nodelist = getnodelist(sfg, opstruct)
% GETNODELIST  Get a list of all used nodes in SFG
% NODELIST = GETNODELIST(SFG) returns a list of all nodes present
%    in the signal flow graph SFG
%
%    SFG - Signal flow graph
%    NODELIST - Resulting list of nodes

% Copyright 2004-2017 Electronics Systems, Dept of EE,
%                Linkoping University, SE-581 83 Linkoping
%                Sweden
% Generated from $Id: getnodelist.m,v 1.4 2004/07/01 14:57:21 oscarg Exp $

% Load operand mapping

if nargin < 2
    opstruct = operandstructure;
end
nooperands = length(opstruct);

nooperations=size(sfg,1);

nodelist=[];
for operand = 1:nooperations
    if (sfg(operand,1) <= nooperands)
        noinout = opstruct(sfg(operand,1)).inout;
        endindex = 3 + sum(noinout) - 1;
        nodelist=[nodelist sfg(operand,3:endindex)];
    else
        error('Invalid or non-implemented operand')
    end
end

nodelist=unique(nodelist');


