function [op_str, type_str] = getopstr(operand, opstruct)

% Check number of input arguments
if nargin < 1
    error('Not enough input arguments');
end
if nargin > 3
    error('Too many input arguments');
end

if nargin < 2
    opstruct=operandstructure;
end

% Load operand mapping
operandmapping;

if operand(1) > length(opstruct)
    error('Unknown operand');
end

shift_op = getidfromname('shift',opstruct);
quant_op = getidfromname('quant',opstruct);
overflow_op = getidfromname('overflow',opstruct);
addsub_op = getidfromname('addsub',opstruct);
% Print the operand
type_str = '';
op_str = sprintf('%-10s', opstruct(operand(1)).name);
switch operand(1)
    case shift_op
        if nargout > 1
            switch operand(6)
                case shift_left, type_str = 'left';
                case shift_right, type_str = 'right';
                otherwise, error('Unknown shift type');
            end
        end
    case quant_op
        if nargout > 1
            switch operand(6)
                case quant_truncation, type_str = 'truncation';
                case quant_rounding, type_str = 'rounding';
                case quant_magnitudetruncation, type_str = 'magnitudetruncation';
                otherwise, error('Unknown quantization type');
            end
        end
    case overflow_op
        if nargout > 1
            switch operand(5)
                case overflow_twosc, type_str = 'twosc';
                case overflow_saturation, type_str = 'saturation';
                otherwise, error('Unknown overflow type');
            end
        end
    case addsub_op
        if nargout > 1
            switch operand(6)
                case addsub_add, type_str = 'add';
                case addsub_sub, type_str = 'sub';
                otherwise, error('Unknown addsub type');
            end
        end
        
end

if nargout > 1
    if opstruct(operand(1)).isadaptor
        switch operand(1 + length(opstruct(operand(1)).argformat))
            case adaptor_ser, type_str = 'series';
            case adaptor_par, type_str = 'parallel';
            case adaptor_sym, type_str = 'symmetric';
            otherwise, error('Unknown adaptor type');
        end
    end
end
