function [sourceop, destops] = getsourceanddesitationfromnode(sfg, node, s)
%GETSOURCEANDDESTINATIONFROMNODE Get the rows corresponding to source and
%destination operations for a given node
%
% Inputs: sfg - signal flow graph
%         node - node number
%         [s] - operandmapping
% Outputs: sourceop - [row outputnumber] in sfg of operation driving node
%          destops - [row inputnumber]-pair in sfg of operations having
%          node as input inputnumber

if nargin < 3
    s = operandstructure;
end
sourceop = [];
destops = [];
for ix = 1:length(sfg(:,1))
    [inn,outn]=getinoutnodes_op(sfg(ix,:), s);
    for outnodeid = 1:length(outn)
    if  (outn(outnodeid) == node)
        sourceop = [ix outnodeid];
    end
    end
    for innodeid = 1:length(inn)
        if (inn(innodeid) == node)
            destops = [destops; [ix innodeid]];
        end
    end
end

