function [starttime,upperbound,lowerbound]=getstarttimes(schedule,operandname,number,s)
% gets the upper and lower bounds on the starttime

%schedule = scha; debug only
%operandname = 'add'; debug only
%number = 2; debug only

if nargin < 4
    s = operandstructure;
end
%-------------------------------------------------
% get the operation index
%-------------------------------------------------
%-------------------------------------------------
% Find operation
%-------------------------------------------------
op = getidfromname(operandname, s);
%-------------------------------------------------
% Extract SFG
%-------------------------------------------------
size_schedule=size(schedule);
nlcount = schedule(1,2);
sfg=schedule(2:size_schedule(1),1:size_schedule(2)-nlcount-2);

same_ops_inst = find(op == sfg(:,1));
if isempty(same_ops_inst)
    error('Operand type not found');
end
same_ops_i = zeros(1,length(same_ops_inst));
for ik = 1:length(same_ops_inst)
    same_ops_i(ik) = sfg(same_ops_inst(ik),2);
end
index = find(number == same_ops_i);

if isempty(index)
    error('operand number mismatch');
end

op_i = same_ops_inst(index);
time_columns_index=size_schedule(2)-2-nlcount;
timecol = [time_columns_index:size_schedule(2)];
st = schedule(2:size_schedule(1),timecol(nlcount+1));
starttime=st(op_i);

%-------------------------------------------------
% get the UB
%-------------------------------------------------
[UB]=getupperbound(schedule,op_i,s);
upperbound=UB;
%-------------------------------------------------
% get the LB
%-------------------------------------------------
[LB]=getlowerbound(schedule,op_i,s);
lowerbound=LB;
%-------------------------------------------------