function sfg = propagateconstants(sfg, constants)

sfg=sortsfg(sfg);


s = operandstructure;
in_op = getidfromname('in',s);
out_op = getidfromname('out',s);
add_op = getidfromname('add',s);
sub_op = getidfromname('sub',s);
constmult_op = getidfromname('constmult',s);
delay_op = getidfromname('delay',s);
quant_op = getidfromname('quant',s);
overflow_op = getidfromname('overflow',s);
negate_op = getidfromname('negate',s);
shift_op = getidfromname('shift',s);
twoport_op = getidfromname('twoport',s);
op_threeport = getidfromname('threeport',s);
op_fourport = getidfromname('fourport',s);
butterfly2_op = getidfromname('butterfly2',s);
constdivision_op = getidfromname('constdiv',s);
mux_op = getidfromname('mux',s);
demux_op = getidfromname('demux',s);
constmac_op = getidfromname('constmac',s);
mult_op = getidfromname('mult',s);
division_op = getidfromname('division',s);
reciprocal_op = getidfromname('reciprocal',s);
mac_op = getidfromname('mac',s);
constant_op = getidfromname('constant',s);

constantrows = find(sfg(:,1) == constant_op);
constantids = sfg(constantrows,2);
constantnodes = sfg(constantrows,3);
constantvalues = sfg(constantrows,4);
constantcount = length(constantrows);
constantcanberemoved = zeros(1,constantcount);
for c = 1:constantcount
    constantvalues(c)
    if nargin == 2
        if ~any(constants == constantvalues(c))
            continue
        end
    end
    switch constantvalues(c)
        case 0
            constantcanberemoved(c) = 1;
            nodevalue = constantnodes(c);
            for op = size(sfg,1):-1:1
                [innodes, outnodes] = getinoutnodes_op(sfg(op,:), s);
                if any(innodes == nodevalue)
                    switch sfg(op,1)
                        case {add_op}
                            if(innodes(1) == nodevalue)
                                newnode = innodes(2);
                            else
                                newnode = innodes(1);
                            end
                            for row = 1:size(sfg,1)
                                noinout = s(sfg(row,1)).inout;
                                for inputcnt = 1:noinout(1)
                                    input = 2 + inputcnt;
                                    if sfg(row, input) == outnodes
                                        sfg(row, input) = newnode;
                                    end
                                end
                            end
                            sfg(op,:)=[];
                        case {sub_op}
                            if(innodes(1) == nodevalue)
                                newnode = innodes(2);
                                for row = 1:size(sfg,1)
                                    noinout = s(sfg(row,1)).inout;
                                    for inputcnt = 1:noinout(1)
                                        input = 2 + inputcnt;
                                        if sfg(row, input) == outnodes
                                            sfg(row, input) = newnode;
                                        end
                                    end
                                end
                            else
                                sfg=addoperand(sfg, 'negate',getfreeopid(sfg,'negate',s),innodes(2),outnodes);
                            end
                            sfg(op,:)=[];

                        case {mult_op, constmult_op, overflow_op, constdivision_op, delay_op, quant_op, shift_op, negate_op}
                            for row = 1:size(sfg,1)
                                noinout = s(sfg(row,1)).inout;
                                for inputcnt = 1:noinout(1)
                                    input = 2 + inputcnt;
                                    if sfg(row, input) == outnodes
                                        sfg(row, input) = nodevalue;
                                    end
                                end
                            end
                            sfg(op,:)=[];
                            constantcanberemoved(c) = 0;
                        case {mac_op}
                            if(any(innodes(1:2) == nodevalue)) 
                                % Multiplier input
                                newnode = innodes(3);
                                for row = 1:size(sfg,1)
                                    noinout = s(sfg(row,1)).inout;
                                    for inputcnt = 1:noinout(1)
                                        input = 2 + inputcnt;
                                        if sfg(row, input) == outnodes
                                            sfg(row, input) = newnode;
                                        end
                                    end
                                end
                                sfg(op,:)=[];
                            else
                                % Adder input
                                sfg=addoperand(sfg,'mult',getfreeopid(sfg,'mult',s), innodes(1:2), outnodes);
                                sfg(op,:)=[];
                            end
                        otherwise
                            constantcanberemoved(c) = 0;
                    end
                end
                
            end
        case 1
            constantcanberemoved(c) = 1;
            nodevalue = constantnodes(c);
            for op = size(sfg,1):-1:1
                [innodes, outnodes] = getinoutnodes_op(sfg(op,:), s);
                if any(innodes == nodevalue)
                    switch sfg(op,1)
                        case {mult_op}
                            if(innodes(1) == nodevalue)
                                newnode = innodes(2);
                            else
                                newnode = innodes(1);
                            end
                            
                            for row = 1:size(sfg,1)
                                noinout = s(sfg(row,1)).inout;
                                for inputcnt = 1:noinout(1)
                                    input = 2 + inputcnt;
                                    if sfg(row, input) == outnodes
                                        sfg(row, input) = newnode;
                                    end
                                end
                            end
                            sfg(op,:)=[];
                        otherwise
                            constantcanberemoved(c) = 0;
                    end
                end
                
            end
            
    end
end
for k=1:length(constantcanberemoved)
    if constantcanberemoved(k)
        sfg=removeoperand(sfg,'constant',constantids(k));
    end
end