function sfg = removeoperand(sfg, operandname, number)
% This function is used to remove an operand from a signal flow graph.
% The operand is simply removed from the signal flow graph without any changes of other operands.
%
% Inputs: sfg - signal flow graph
%         operandname - operand name as a string
%         number - operand ID number
% Output: sfg - updated signal flow graph


if nargin < 3
    error('Not enough input arguments');
end
if nargin > 3
    error('Too many input arguments');
end


op = getidfromname(operandname);

% Find and remove the row from the sfg
id_op = find(op == sfg(:, 1));
id_no = find(number == sfg(:, 2));
index = 1;
while isempty(find(id_op(index) == id_no))
    index = index + 1;
    if index > length(id_op)
        error('The operand could not be found!');
    end
end
row_op = id_op(index);
sfg(row_op, :) = [];

