function [newsfg] = replaceaddandsubwithaddsub( sfg, type)
% Replace 'add' and 'sub' operations with 'addsub' operations
%
% SFG/SCHEDULE 
% TYPE 'sfg' (default) or 'schedule'

s = operandstructure;
operandmapping;

add_op = getidfromname('add',s);
sub_op = getidfromname('sub',s);
addsub_op = getidfromname('addsub',s);

scheduleinfo = [];
timinginfo = [];
if nargin == 2
    if strcmpi(type,'schedule')
        scheduleinfo = sfg(1,:);
        numberoflaps = scheduleinfo(2);
        timingcols = 3+numberoflaps;
        timinginfo = sfg(2:end,size(sfg,2)-timingcols+1:end);
        sfg = sfg(2:end,1:size(sfg,2)-timingcols);
    end
end

for k = 1:size(sfg,1)
    optype = -1;
    if sfg(k,1) == add_op
        optype = addsub_add;
    else 
        if sfg(k,1) == sub_op
            optype = addsub_sub;
        end
    end
    
    if optype ~= -1
        if size(sfg,2) == 5
            sfg = [sfg, NaN*ones(size(sfg,1), 1)];
            if ~isempty(scheduleinfo)
                scheduleinfo = [scheduleinfo NaN];
            end
        end
        sfg(k,6) = optype;
        opnumber = sfg(k,2);
        for l = 1:size(sfg,1)
            if sfg(l,1) == addsub_op
                if sfg(l,2) == opnumber
                    opnumber = getfreeopid(sfg,'addsub');
                end
            end
        end
        sfg(k,1) = addsub_op;
        sfg(k,2) = opnumber;
    end
    
end

newsfg = [scheduleinfo;[sfg timinginfo]];
end

