function [newsfg] = setinputtoconstant(sfg, inputids, constant)
% Set one or more input nodes to a constant value

if nargin < 3
    error('Too few input arguments')
end

s = operandstructure;

newnode = getfreenode(sfg);
newid = getfreeopid(sfg, 'constant', s);
in_op = getidfromname('in',s);

newsfg = addoperand(sfg, 'constant', newid, [], newnode, constant);

nodelist = [];
for op = 1:size(newsfg,1)
    if (newsfg(op,1) == in_op)
        if any(newsfg(op,2) == inputids)
            nodelist = [nodelist newsfg(op,3)];
        end
    end
end

for nodevalue = nodelist
    for op = 1:size(newsfg,1)
        [innodes, ~] = getinoutnodes_op(newsfg(op,:),s);
        if(any(innodes == nodevalue))
            for inputcnt = 1:length(innodes)
                input = 2 + inputcnt;
                if newsfg(op, input) == nodevalue
                    newsfg(op, input) = newnode;
                end
            end
        end
    end
end

for id = inputids
    newsfg = removeoperand(newsfg, 'in', id);
end


end

