function [A, B, C, D] = sfg2ss(sfg)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

s = operandstructure;
in_op = getidfromname('in',s);
out_op = getidfromname('out',s);
delay_op = getidfromname('delay',s);
quant_op = getidfromname('quant',s);
overflow_op = getidfromname('overflow',s);

ops = sfg(:,1);
if any(ops==quant_op) || any(ops==overflow_op)
    warning('SFG containts non-linear operations. State-space representation will not be correct.')
end

in_count = nnz(ops==in_op);
in_ids = sfg(ops==in_op,2);
out_count = nnz(ops==out_op);
out_ids = sfg(ops==out_op,2);
delay_count = nnz(ops==delay_op);
delay_ids = sfg(ops==delay_op,2);

A = zeros(delay_count,delay_count);
B = zeros(delay_count,in_count);
C = zeros(out_count,delay_count);
D = zeros(out_count,in_count);

% Inputs
for i = 1:in_count
    input = in_ids(i);
    inputvalues = zeros(in_count,1);
    inputvalues(in_ids==input) = 1;
    [outputs, outputids, registers, registerids] = simulate(sfg, inputvalues, in_ids);
    for o=1:out_count
        D(out_ids(o),i)=getnodevalues(outputs, outputids, out_ids(o));
    end
    for r=1:delay_count
        B(delay_ids(r),i)=getnodevalues(registers, registerids, delay_ids(r));
    end
end

% Delays
inputvalues = zeros(in_count,1);
for i = 1:delay_count
%    delay = delay_ids(i);
%    delayvalues=zeros(delay_count,1);
%    delayvalues(delay_ids==delay) = 1;
    [outputs, outputids, registers, registerids] = simulate(sfg, inputvalues, in_ids, 1, delay_ids(i));
    for o=1:out_count
        C(out_ids(o),i)=getnodevalues(outputs, outputids, out_ids(o));
    end
    for r=1:delay_count
        A(delay_ids(r),i)=getnodevalues(registers, registerids, delay_ids(r));
    end
end

end

