function schedule = updatepetiming(schedule, timing, operandname, operandnumber)
%schedule = updatepetiming(schedule, timing, operandname, operandnumber)

if nargin < 3
    error('updatepetiming: not enough input arguments')
end

if nargin < 4
    allids = 1;
else
    allids = 0;
end

op = getidfromname(operandname);

size_schedule=size(schedule);
time_columns_index=size_schedule(2)-4;
timecol = [time_columns_index:1:size_schedule(2)];

new_latency = timing(1);
new_exectime = timing(2);

if allids
    ids = [false; schedule(2:end, 1) == op];
else
    ids = [false; (schedule(2:end, 1) == op) & ...
        (schedule(2:end, 2) == operandnumber)];
end

schedule(ids, timecol(4)) = new_latency;
schedule(ids, timecol(5)) = new_exectime;

